import 'dart:io';

import 'package:cydrive_sdk/models/account.pb.dart';
import 'package:cydrive_sdk/utils.dart';
import 'package:flutter_test/flutter_test.dart';

import 'package:cydrive_sdk/cydrive_sdk.dart';

void main() {
  Account account =
      Account(email: "test@cydrive.io", password: passwordHash("hello_world"));
  final client = CyDriveClient("127.0.0.1", account: account);
  test('login', () async {
    var isLogin = await client.login();
    var account = client.account;
    expect(isLogin, true);
  });

  test('get file list', () async {
    var isLogin = await client.login();
    expect(isLogin, true);

    var list = await client.listDir("");
    print(list);

    list = await client.listDir("cy");
    print(list);
  });

  test('download', () async {
    var isLogin = await client.login();
    expect(isLogin, true);

    await client.download('test.txt', 'temp/test.txt', shouldTruncate: true);
    expect(File('temp/test.txt').readAsStringSync(), 'this is a test file');
  });

  test('upload', () async {
    var isLogin = await client.login();
    expect(isLogin, true);

    await client.upload('temp/test.txt', 'dart-sdk/upload_test.txt');
    await client.download('dart-sdk/upload_test.txt', 'temp/re-download.txt',
        shouldTruncate: true);
    expect(
        File('temp/re-download.txt').readAsStringSync(), 'this is a test file');
  });

  test('message_service', () async {
    var isLogin = await client.login();
    expect(isLogin, true);

    bool ok = await client.connectMessageService();
    expect(ok, true);
  });
}
